; ** por compatibilidad se omiten tildes **
; ==============================================================================
; TALLER System Programming - ORGANIZACION DE COMPUTADOR II - FCEN
; ==============================================================================

%include "print.mac"

global start


; COMPLETAR - Agreguen declaraciones extern según vayan necesitando
extern A20_enable
extern GDT_DESC
extern IDT_DESC
extern screen_draw_layout
extern idt_init
extern pic_enable
extern pic_reset
extern tss_init
extern mmu_init_kernel_dir
extern copy_page
extern mmu_init_task_dir
; COMPLETAR - Definan correctamente estas constantes cuando las necesiten
%define CS_RING_0_SEL 8   
; 1 shifteado 3 bits
%define DS_RING_0_SEL 24  
 

BITS 16
;; Saltear seccion de datos
jmp start

;;
;; Seccion de datos.
;; -------------------------------------------------------------------------- ;;
start_rm_msg db     'Iniciando kernel en Modo Real'
start_rm_len equ    $ - start_rm_msg

segment_selector_data_0 db 0x0018
start_pm_msg db     'Iniciando kernel en Modo Protegido'
start_pm_len equ    $ - start_pm_msg

;;S

;; Seccion de código.
;; -------------------------------------------------------------------------- ;;

;; Punto de entrada del kernel.
BITS 16
start:
    ; COMPLETAR - Deshabilitar interrupciones
    cli

    ; Cambiar modo de video a 80 X 50
    mov ax, 0003h
    int 10h ; set mode 03h
    xor bx, bx
    mov ax, 1112h
    int 10h ; load 8x8 font

    ; COMPLETAR - Imprimir mensaje de bienvenida - MODO REAL
    ; (revisar las funciones definidas en print.mac y los mensajes se encuentran en la
    ; sección de datos)
    print_text_rm start_rm_msg, start_rm_len, 0x0A, 0, 0

    ; COMPLETAR - Habilitar A20
    ; (revisar las funciones definidas en a20.asm)

    call A20_enable

    ; COMPLETAR - Cargar la GDT

    lgdt [GDT_DESC] ; es el puntero a la GDT
 
    
    mov eax, cr0
    or eax, 1
    mov cr0, eax

    ; COMPLETAR - Saltar a modo protegido (far jump)
    ; (recuerden que un far jmp se especifica como jmp CS_selector:address)
    ; Pueden usar la constante CS_RING_0_SEL definida en este archivo

    jmp CS_RING_0_SEL:modo_protegido ; es 8 porque el index del segmento de codigo de la gdt era 1 y lo shifteamos 3

BITS 32
modo_protegido:
    ; COMPLETAR - A partir de aca, todo el codigo se va a ejectutar en modo protegido
    ; Establecer selectores de segmentos DS, ES, GS, FS y SS en el segmento de datos de nivel 0
    ; Pueden usar la constante DS_RING_0_SEL definida en este archivo
    mov ax, DS_RING_0_SEL      ; selector de segmento del segmento de datos de nivel 0 en hexadecimal
    mov ds, ax   
    mov es, ax
    mov gs, ax
    mov fs, ax
    mov ss, ax

    ; COMPLETAR - Establecer el tope y la base de la pila
    mov esp, 0x25000
    mov ebp, 0x25000
    ; COMPLETAR - Imprimir mensaje de bienvenida - MODO PROTEGIDO
   ; print_text_pm start_pm_msg, start_pm_len, 0x0A, 1, 0
    ; COMPLETAR - Inicializar pantalla
   call screen_draw_layout

    ; Cargamos las interrupciones
    call idt_init
    lidt [IDT_DESC] ; es el puntero a la IDT
 
    ; Habilitamos las interrupciones externas
    call pic_reset
    call pic_enable
    
    ; Cargamos las páginas
    call mmu_init_kernel_dir
    mov cr3, eax
    mov eax, cr0
    or eax, 0x80000000   ;el bit 31 activa la paginacion
    mov cr0, eax

    ;mov eax, 0x0000ffff
    ;mov ebx, 0x00008f00
    ;push eax
    ;push ebx
    ;call copy_page
    ;pop ebx
    ;pop eax

    mov edi, 0x18000
    push edi        
    call mmu_init_task_dir
    ;pop edx
    mov edx, cr3            ;guardo el cr3 del kernel
    mov cr3, eax            ;dudoso
    mov ecx, 0x1
    mov [0x07000000], ecx    ;escritura #1
    mov [0x07000004], ecx    ;escritura #2  
    mov cr3, edx             ;vuelve a la normalidad

    ; call tasks_screen_draw
    ; mov ax, GDT_IDX_TASK_INITIAL
    ; call tss_init
                        
    ; ltr ax

    ; jmp GDT_IDX_TASK_IDLE:0

    ; Ciclar infinitamente 
    mov eax, 0xFFFF
    mov ebx, 0xFFFF
    mov ecx, 0xFFFF
    mov edx, 0xFFFF
    jmp $

;; -------------------------------------------------------------------------- ;;

%include "a20.asm"



